%define oraepoch 2

%define oravers 12.1

%define pkgname DBD-Oracle-1.52.tar.gz
%define filelist %{pkgname}-%{version}-filelist
%define NVR %{pkgname}-%{version}-%{release}
%{!?maketest: %define maketest 0}

name:      perl-DBD-Oracle
summary:   Perl bindings for ORACLE module
version:   1.74
release:   3%{?dist}
vendor:    pythian@cpan.org
packager:  Jaroslaw.Polok@cern.ch
license:   Artistic
group:     Applications/CPAN
url:       http://www.cpan.org
buildroot: %{_tmppath}/%{name}-%{version}-%(id -u -n)
prefix:    %(echo %{_prefix})
Buildrequires: oracle-instantclient-devel >= %{oraepoch}:%{oraver}
%if 0%{?rhel} >= 6
BuildRequires: perl-ExtUtils-MakeMaker
%else
BuildRequires: perl
%endif
BuildRequires: perl-DBI
source:    http://search.cpan.org//CPAN/authors/id/P/PY/PYTHIAN/DBD-Oracle-%{version}.tar.gz
patch0:    perl-DBD-Oracle-lib64.patch
patch1:    DBD-Oracle-noperlTkPod.patch
Patch100:  DBD-Oracle-1.32-Makefile.PL.patch
Patch101:  perl-DBD-Oracle-makefile.patch

Requires: oracle-instantclient-basic >= %{oraepoch}:%{oraver}

ExclusiveArch: x86_64

%description
Perl connector ORACLE databases. Uses the free-but-proprietary ORACLE instantclient.

%prep
%setup -q -n DBD-Oracle-%{version}
chmod -R u+w %{_builddir}/DBD-Oracle-%{version}
#patch0 -p0 -b .64b
#patch1 -p1 -b .nopod
#patch100 -R -p0 

%build
ora_dir=/usr/lib/oracle/%{oravers}/client64
ora_libhome=$ora_dir/lib

echo "ORACLE_HOME=$ora_dir";

export ORACLE_HOME=$ora_dir;
%if %{maketest}
[ -z "$ORACLE_USERID" ] && { echo "*** need valid ORACLE_USERID= name/pass ***" ; exit -1; } 
[ -z "$ORACLE_DSN" ] && { echo "*** need valid ORACLE_DSN= DBI:Oracle:devdb ***" ; exit -1; } 
%endif

#grep -rsl '^#!.*perl' . |
#grep -v '.bak$' |xargs --no-run-if-empty \
#%__perl -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)'
CFLAGS="$RPM_OPT_FLAGS"
%{__perl} Makefile.PL -m /usr/share/oracle/%{oravers}/client64/demo/demo.mk -V %{oravers}

#perl -p -i -e 's#/usr/local/include#/usr/include/oracle/%{oravers}/client/#' Makefile
#perl -p -i -e 's#/usr/local/#/usr/#' Makefile

#patch -p1 < %{PATCH101}

echo "LIBHOME=$ora_libhome";

export LIBHOME=$ora_libhome
%{__make} 
%if %maketest
%{__make} test
%endif

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%{makeinstall} `%{__perl} -MExtUtils::MakeMaker -e ' print \$ExtUtils::MakeMaker::VERSION <= 6.05 ? qq|PREFIX=%{buildroot}%{_prefix}| : qq|DESTDIR=%{buildroot}| '`

cmd=/usr/share/spec-helper/compress_files
[ -x $cmd ] || cmd=/usr/lib/rpm/brp-compress
[ -x $cmd ] && $cmd

# SuSE Linux
if [ -e /etc/SuSE-release -o -e /etc/UnitedLinux-release ]
then
    %{__mkdir_p} %{buildroot}/var/adm/perl-modules
    %{__cat} `find %{buildroot} -name "perllocal.pod"`  \
        | %{__sed} -e s+%{buildroot}++g                 \
        > %{buildroot}/var/adm/perl-modules/%{name}
fi

# remove special files
find %{buildroot} -name "perllocal.pod" \
    -o -name ".packlist"                \
    -o -name "*.bs"                     \
    |xargs -i rm -f {}

# no empty directories
#find %{buildroot}%{_prefix}             \
#    -type d -depth                      \
#    -exec rmdir {} \; 2>/dev/null

%{__perl} -MFile::Find -le '
    find({ wanted => \&wanted, no_chdir => 1}, "%{buildroot}");
    print "%doc  Changes hints Todo README.help.txt README";
    for my $x (sort @dirs, @files) {
        push @ret, $x unless indirs($x);
        }
    print join "\n", sort @ret;

    sub wanted {
        return if /auto$/;

        local $_ = $File::Find::name;
        my $f = $_; s|^\Q%{buildroot}\E||;
        return unless length;
        return $files[@files] = $_ if -f $f;

        $d = $_;
        /\Q$d\E/ && return for reverse sort @INC;
        $d =~ /\Q$_\E/ && return
            for qw|/etc %_prefix/man %_prefix/bin %_prefix/share|;

        $dirs[@dirs] = $_;
        }

    sub indirs {
        my $x = shift;
        $x =~ /^\Q$_\E\// && $x ne $_ && return 1 for @dirs;
        }
    ' > %filelist

[ -z %filelist ] && {
    echo "ERROR: empty %files listing"
    exit -1
    }

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -f %filelist
%defattr(-,root,root)

%changelog
* Thu Dec 03 2015 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 1.74-3
- fix reqs again.

* Fri Sep 12 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 1.74-2
- fix reqs

* Wed Sep 10 2014 Jaroslaw Polok <Jaroslaw.Polok@cern.ch> - 1.74
- first build on el7

* Wed Oct 10 2012 Jan van Eldik <Jan.van.Eldik@cern.ch> 1.34-5.cern
- rebuild against oracle version 11.2.0.3.0-5.slc6

* Fri Nov 18 2011 Jaroslaw.Polok@cern.ch - 1.34-1.cern
- updated to 1.34

* Tue Oct 18 2011 Jaroslaw.Polok@cern.ch - 1.32-1.cern
- Build for SLC6

* Thu Mar 26 2009 jan.iven@cern.ch - 1.22-2.cern
- remove dependency on Tk::Pod (only used in oraexplain, and only for some help button..dropped).

* Fri Dec 19 2008 jan.iven@cern.ch - 1.22-1.cern
- go to 1.22, be more forgiving on exact instantclient version

* Mon Oct 16 2006 iven@lxcert-i386
- Initial build.
